#!/usr/bin/python

# file: array_utils.py

"Array related functions"

import types;

LARGE_NUMBER = 10000

def findIndex(list, elem):
    "Returns the index of a data item in an array; \
    returns -1 if the data item is not found"
    if (elem not in list):
        return -1;
    return list.index(elem);
    
def initArray(size, val):
    "returns a array of 'size' size initialized to 'val'"
    array = [];
    for i in range(size):
        if type(val) is types.ListType:
            array.append(val[:]);
        else:
            array.append(val);
    return array;

def initMatrix(maxRow, maxCol, val):
    "Returns a matrix of ('maxRow' x 'maxCol') initialized to 'val'"
    matrix = [];
    for i in range(maxRow):
        matrix.append(initArray(maxCol, val));
    return matrix;
    
def delCol(matrix, col):
    "Deletes a column of a matrix"
    for i in range(len(matrix)):
        del matrix[i][col];
    return matrix;

def fillCol(matrix, col, val):
    "Fill the column 'col' of matrix 'matrix' with value 'val'"
    for i in range(len(matrix)):
        matrix[i][col] = val;
    return matrix;

def findAvg(array):
    "Finds the average of elements"
    avg = 0;
    for elem in array:
        avg += elem;
    return avg/len(array);

def printMatrix(matrix, format):
    "Print the matrix"
    for i in range(len(matrix)):
        print "[",
        for j in range(len(matrix[i])):
            print format % matrix[i][j],
        print "]"

def findMaxCol(matrix, col):
    maxVal = -1 * LARGE_NUMBER
    for row in matrix:
        if row[col] > maxVal:
            maxVal = row[col]
    return maxVal

def findMinCol(matrix, col):
    minVal = LARGE_NUMBER
    for row in matrix:
        if row[col] < minVal:
            minVal = row[col]
    return minVal
