#!/usr/bin/python

# file: cartesian.py

"Functions related to a Cartesian coordinate space"

import math, random

def findDist(coords1, coords2):
    "Find the distance between two coordinates 'coords1' and 'coords2'"
    if (len(coords1) != len(coords2)):
        print "cartesian.py error: dimension mismatch in distFind()";
    dist = 0;
    for i in range(len(coords1)):
        dist += (coords1[i] - coords2[i])*(coords1[i] - coords2[i]);
    return math.sqrt(dist);

def findDiameter(coords):
    "Finds the diameter of the space defined by 'coords'"
    maxDist = 0.0;
    for i in range(len(coords)):
        for j in range(i+1,len(coords)):
            dist = findDist(coords[i], coords[j]);
            if (dist > maxDist):
                maxDist = dist;
    return maxDist;

def randDistCoords(center, low_range, high_range):
    """Generate a random coordinate from center at a distance within
    the specified range and in a random direction"""
    # random distance within a range
    dist = low_range + (high_range - low_range) * random.random()
    # and in a random direction
    deg = 2 * math.pi * random.random()
    # calculate the coordinates of the new node
    randCoords = [0 for i in range(2)]
    randCoords[0] = center[0] + dist * math.cos(deg)
    randCoords[1] = center[1] + dist * math.sin(deg)
    return randCoords
