#!/usr/bin/python

import sys

LARGE_NUMBER = 10000
progBar = ["|", "/", "-", "\\"]

def shortestPathDist(delayMatrix, progress):
    "Calculates all-to-all shortest path delays"
    progCount = 0 # to show the progress
    noOfNodes = len(delayMatrix)
    for source in range(noOfNodes):
        foundPath = []   # found shortest paths to these nodes
        targets = []     # shortest paths to these nodes to be found
        # populate the above arrays
        for i in range(noOfNodes):
            if (delayMatrix[source][i] != -1):
                foundPath.append(i)
            else:
                targets.append(i)
        # the shortest path algorithm
        while len(foundPath) < noOfNodes:
            if progress:
                # printing progress
                print "\b\b%s" % progBar[progCount % len(progBar)],
                sys.stdout.flush()
            closest = None
            fromNode = None
            closestDist = LARGE_NUMBER
            # find the next closest node to the current set
            for i in foundPath:
                for j in targets:
                    if delayMatrix[i][j] != -1 and delayMatrix[i][j] < closestDist:
                        closestDist = delayMatrix[i][j]
                        closest = j
                        fromNode = i
            if closest == None:
                print "path not found; source node", source
                print foundPath
                sys.exit(1)
            foundPath.append(closest)
            targets.remove(closest)
            delayMatrix[source][closest] = delayMatrix[source][fromNode] + closestDist
            delayMatrix[closest][source] = delayMatrix[source][closest]
            progCount += 1
    return
        
        
    
